/*
    Copyright (C) 2012 Bartosz Broda, Jacek Bochenek, Łukasz Biłeńkij, 
    Damian Jaworski, Wojciech Mazur, Dominik Piasecki, Maciej Piasecki, 
    Radosław Ramocki
    
    This program is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option)
any later version.

    This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. 

    See the LICENSE and COPYING files for more details.
*/

#include "../comparator_stdheaders.h"
#include "PMIComparision.h"
#include "../weights/SimpleMIWeight.h"
#include "../simfunctions/CosineFunction.h"
#include "../simfunctions/LinSimilarity.h"

namespace smartcomparator
{
	namespace compare
	{
		PMIComparision::PMIComparision(Matrices::SuperMatrixPtr pMatrix, bool discount, double mi_threshold)
			: CompareFunction(pMatrix)
		{
			m_pWeight = weights::WeightFeaturePtr( new weights::SimpleMIWeight(pMatrix, discount, mi_threshold) );
			simfunctions::CosineFunction *fun = new  simfunctions::CosineFunction(pMatrix);
			m_pSimfun = simfunctions::SimilarityFunctionPtr(fun);
		}

		PMIComparision::~PMIComparision() 
		{
		}

		PMIQuantifiedComparision::PMIQuantifiedComparision(Matrices::SuperMatrixPtr pMatrix, bool discount)
			: CompareFunction(pMatrix)
		{
			m_pWeight = weights::WeightFeaturePtr( new weights::PMIQuantifiedWeight(pMatrix, discount) );
			simfunctions::CosineFunction *fun = new  simfunctions::CosineFunction(pMatrix);
			m_pSimfun = simfunctions::SimilarityFunctionPtr(fun);
		}

	}
}
